<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_FareGroup ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_FareGroup extends AbstractStructArrayBase
{
    /**
     * The FareGroup
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_FareGroup[]
     */
    public $FareGroup;
    /**
     * Constructor method for ArrayOfJP_FareGroup
     * @uses ArrayOfJP_FareGroup::setFareGroup()
     * @param \StructType\JP_FareGroup[] $fareGroup
     */
    public function __construct(array $fareGroup = array())
    {
        $this
            ->setFareGroup($fareGroup);
    }
    /**
     * Get FareGroup value
     * @return \StructType\JP_FareGroup[]|null
     */
    public function getFareGroup()
    {
        return $this->FareGroup;
    }
    /**
     * Set FareGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FareGroup[] $fareGroup
     * @return \ArrayType\ArrayOfJP_FareGroup
     */
    public function setFareGroup(array $fareGroup = array())
    {
        foreach ($fareGroup as $arrayOfJP_FareGroupFareGroupItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_FareGroupFareGroupItem instanceof \StructType\JP_FareGroup) {
                throw new \InvalidArgumentException(sprintf('The FareGroup property can only contain items of \StructType\JP_FareGroup, "%s" given', is_object($arrayOfJP_FareGroupFareGroupItem) ? get_class($arrayOfJP_FareGroupFareGroupItem) : gettype($arrayOfJP_FareGroupFareGroupItem)), __LINE__);
            }
        }
        $this->FareGroup = $fareGroup;
        return $this;
    }
    /**
     * Add item to FareGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FareGroup $item
     * @return \ArrayType\ArrayOfJP_FareGroup
     */
    public function addToFareGroup(\StructType\JP_FareGroup $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_FareGroup) {
            throw new \InvalidArgumentException(sprintf('The FareGroup property can only contain items of \StructType\JP_FareGroup, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FareGroup[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_FareGroup|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_FareGroup|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_FareGroup|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_FareGroup|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_FareGroup|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareGroup
     */
    public function getAttributeName()
    {
        return 'FareGroup';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_FareGroup
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
